package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class ActorEvents_0 extends ActorScript
{
	public var _DrawHookshot:Bool;
	public var _Hookshot:Actor;
	public var _cordstartxoffset:Float;
	public var _cordstartyoffset:Float;
	public var _hookxoffset:Float;
	public var _hookyoffset:Float;
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Draw Hookshot", "_DrawHookshot");
		_DrawHookshot = false;
		nameMap.set("Hookshot", "_Hookshot");
		nameMap.set("cord start x offset", "_cordstartxoffset");
		_cordstartxoffset = 0.0;
		nameMap.set("cord start y offset", "_cordstartyoffset");
		_cordstartyoffset = 0.0;
		nameMap.set("hook x offset", "_hookxoffset");
		_hookxoffset = 0.0;
		nameMap.set("hook y offset", "_hookyoffset");
		_hookyoffset = 0.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				engine.moveCamera(actor.getXCenter(), actor.getYCenter());
				actor.makeAlwaysSimulate();
				if((Engine.engine.getGameAttribute("Hookshot pull") == true))
				{
					actor.disableBehavior("4 Way Movement");
					if((Engine.engine.getGameAttribute("actor direction") == "right"))
					{
						if(((actor.getX() + (actor.getWidth())) < (_Hookshot.getX() + ((_Hookshot.getWidth()) + 2))))
						{
							actor.setXVelocity(30);
							actor.setYVelocity(0);
						}
						else
						{
							Engine.engine.setGameAttribute("Hookshot pull", false);
							recycleActor(_Hookshot);
							actor.enableBehavior("4 Way Movement");
						}
					}
					if((Engine.engine.getGameAttribute("actor direction") == "left"))
					{
						if((actor.getX() > (1 + _Hookshot.getX())))
						{
							actor.setXVelocity(-30);
							actor.setYVelocity(0);
						}
						else
						{
							Engine.engine.setGameAttribute("Hookshot pull", false);
							recycleActor(_Hookshot);
							actor.enableBehavior("4 Way Movement");
						}
					}
				}
				else
				{
					if(isKeyPressed("up"))
					{
						Engine.engine.setGameAttribute("actor direction", "up");
					}
					else if(isKeyPressed("down"))
					{
						Engine.engine.setGameAttribute("actor direction", "down");
					}
					else if(isKeyPressed("left"))
					{
						Engine.engine.setGameAttribute("actor direction", "left");
					}
					else if(isKeyPressed("right"))
					{
						Engine.engine.setGameAttribute("actor direction", "right");
					}
					if(isKeyPressed("z"))
					{
						createRecycledActor(getActorType(2), actor.getXCenter(), actor.getYCenter(), Script.FRONT);
					}
					if((isKeyPressed("x") && (Engine.engine.getGameAttribute("skill") == "fire arrow")))
					{
						createRecycledActor(getActorType(6), actor.getXCenter(), actor.getYCenter(), Script.FRONT);
					}
					else if((isKeyPressed("x") && (Engine.engine.getGameAttribute("skill") == "ice arrow")))
					{
						createRecycledActor(getActorType(11), actor.getXCenter(), actor.getYCenter(), Script.FRONT);
					}
					else if((isKeyPressed("x") && (Engine.engine.getGameAttribute("skill") == "hook")))
					{
						createRecycledActor(getActorType(23), actor.getXCenter(), actor.getYCenter(), Script.FRONT);
						_Hookshot = getLastCreatedActor();
						propertyChanged("_Hookshot", _Hookshot);
						_DrawHookshot = true;
						propertyChanged("_DrawHookshot", _DrawHookshot);
					}
					else if(isKeyPressed("x"))
					{
						return;
					}
				}
			}
		});
		
		/* ========================= When Drawing ========================= */
		addWhenDrawingListener(null, function(g:G, x:Float, y:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				/* "Hookshot (dont mess with code)" */ if(_DrawHookshot)
				{
					g.strokeColor = Utils.getColorRGB(255,255,0);
					g.strokeSize = Std.int(4);
					g.translateToScreen();
					if((hasValue(_Hookshot)))
					{
						if(_Hookshot.isAlive())
						{
							if((Engine.engine.getGameAttribute("actor direction") == "right"))
							{
								_cordstartxoffset = asNumber(16);
								propertyChanged("_cordstartxoffset", _cordstartxoffset);
								_cordstartyoffset = asNumber(23);
								propertyChanged("_cordstartyoffset", _cordstartyoffset);
								_hookxoffset = asNumber(2);
								propertyChanged("_hookxoffset", _hookxoffset);
								_hookyoffset = asNumber(8);
								propertyChanged("_hookyoffset", _hookyoffset);
								g.drawLine((actor.getScreenX() + _cordstartxoffset), (actor.getScreenY() + _cordstartyoffset), (_Hookshot.getScreenX() + _hookxoffset), (_Hookshot.getScreenY() + _hookyoffset));
								g.strokeSize = Std.int(1);
								g.strokeColor = Utils.getColorRGB(255,0,0);
								g.drawLine((actor.getScreenX() + _cordstartxoffset), (actor.getScreenY() + _cordstartyoffset), (_Hookshot.getScreenX() + _hookxoffset), (_Hookshot.getScreenY() + _hookyoffset));
							}
							else if((Engine.engine.getGameAttribute("actor direction") == "left"))
							{
								_cordstartxoffset = asNumber(11);
								propertyChanged("_cordstartxoffset", _cordstartxoffset);
								_cordstartyoffset = asNumber(23);
								propertyChanged("_cordstartyoffset", _cordstartyoffset);
								_hookxoffset = asNumber(8);
								propertyChanged("_hookxoffset", _hookxoffset);
								_hookyoffset = asNumber(8);
								propertyChanged("_hookyoffset", _hookyoffset);
								g.drawLine((actor.getScreenX() + _cordstartxoffset), (actor.getScreenY() + _cordstartyoffset), (_Hookshot.getScreenX() + _hookxoffset), (_Hookshot.getScreenY() + _hookyoffset));
								g.strokeSize = Std.int(1);
								g.strokeColor = Utils.getColorRGB(255,0,0);
								g.drawLine((actor.getScreenX() + _cordstartxoffset), (actor.getScreenY() + _cordstartyoffset), (_Hookshot.getScreenX() + _hookxoffset), (_Hookshot.getScreenY() + _hookyoffset));
							}
						}
					}
				}
			}
		});
		
		/* ======================== Actor of Type ========================= */
		addCollisionListener(actor, function(event:Collision, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && sameAsAny(getActorType(21), event.otherActor.getType(),event.otherActor.getGroup()))
			{
				Engine.engine.setGameAttribute("life", (Engine.engine.getGameAttribute("life") + 4));
			}
		});
		
		/* ======================= Member of Group ======================== */
		addCollisionListener(actor, function(event:Collision, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && sameAsAny(getActorGroup(5),event.otherActor.getType(),event.otherActor.getGroup()))
			{
				if((Engine.engine.getGameAttribute("invincibility") == false))
				{
					Engine.engine.setGameAttribute("life", (Engine.engine.getGameAttribute("life") - 2));
					if(event.thisFromTop)
					{
						actor.setY((actor.getY() + 20));
					}
					else if(event.thisFromBottom)
					{
						actor.setY((actor.getY() - 20));
					}
					else if(event.thisFromLeft)
					{
						actor.setX((actor.getX() + 20));
					}
					else if(event.thisFromRight)
					{
						actor.setX((actor.getX() - 20));
					}
					Engine.engine.setGameAttribute("invincibility", true);
					runLater(1000 * 1.5, function(timeTask:TimedTask):Void
					{
						Engine.engine.setGameAttribute("invincibility", false);
					}, actor);
				}
				else if((Engine.engine.getGameAttribute("invincibility") == true))
				{
					return;
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}